import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:gz_orientation/gz_orientation.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return const MaterialApp(
      home: HomePage(),
    );
  }
}

class HomePage extends StatelessWidget {
  const HomePage({super.key});

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('HomePage'),
      ),
      body: Center(
        child: GestureDetector(
          onTap: () {
            Navigator.of(context)
                .push(MaterialPageRoute(builder: (BuildContext context) {
              return const TestPage();
            }));
          },
          child: Container(
            color: Colors.blue,
            width: 120.0,
            height: 30.0,
            child: const Text('To Test Page'),
          ),
        ),
      ),
    );
  }
}

class TestPage extends StatefulWidget {
  const TestPage({super.key});

  @override
  State<TestPage> createState() => _TestPageState();
}

class _TestPageState extends State<TestPage> {
  @override
  void dispose() {
    // TODO: implement dispose
    GzOrientation.setPreferredOrientations([DeviceOrientation.portraitUp]);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    Size size = MediaQuery.of(context).size;
    return Scaffold(
      appBar: AppBar(
        title: const Text('TestPage'),
      ),
      body: SizedBox(
        width: size.width,
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            GestureDetector(
              onTap: () {
                GzOrientation.forceOrientation(
                    DeviceOrientation.landscapeRight);
              },
              child: Container(
                color: Colors.blue,
                width: 160.0,
                height: 30.0,
                alignment: Alignment.center,
                child: const Text('force landscapeRight'),
              ),
            ),
            GestureDetector(
              onTap: () {
                GzOrientation.forceOrientation(DeviceOrientation.portraitUp);
              },
              child: Container(
                color: Colors.blue,
                width: 160.0,
                height: 30.0,
                alignment: Alignment.center,
                child: const Text('force portraitUp'),
              ),
            ),
            const Text('在 dispose 时，设置默认方向 portraitUp')
          ],
        ),
      ),
    );
  }
}
