import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'gz_orientation_method_channel.dart';

abstract class GzOrientationPlatform extends PlatformInterface {
  /// Constructs a GzOrientationPlatform.
  GzOrientationPlatform() : super(token: _token);

  static final Object _token = Object();

  static GzOrientationPlatform _instance = MethodChannelGzOrientation();

  /// The default instance of [GzOrientationPlatform] to use.
  ///
  /// Defaults to [MethodChannelGzOrientation].
  static GzOrientationPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [GzOrientationPlatform] when
  /// they register themselves.
  static set instance(GzOrientationPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
